---
title: WindowClient.visibilityState
slug: Web/API/WindowClient/visibilityState
tags:
  - API
  - Experimental
  - Property
  - Reference
  - Service Workers
  - ServiceWorker
  - WindowClient
  - visibilityState
---
<div>{{APIRef("Service Workers API")}}</div>

<p>The <strong><code>visibilityState</code></strong> read-only property of the {{domxref("WindowClient")}} interface indicates the visibility of the current client. This value can be one of <code>"hidden"</code>, <code>"visible"</code>, or <code>"prerender"</code>.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>myVisState</em> = <em>windowClient</em>.visibilityState;</pre>

<h3 id="Value">Value</h3>

<p>A {{domxref("DOMString")}} (See {{domxref("Document.visibilityState")}} for values).</p>

<h2 id="Example">Example</h2>

<pre class="brush: js">event.waitUntil(clients.matchAll({
    type: "window"
  }).then(function(clientList) {
    for (let i = 0; i &lt; clientList.length; i++) {
      let client = clientList[i];
      if (client.url == '/' &amp;&amp; 'focus' in client) {
        if (client.visibilityState === 'hidden')
          return client.focus();
        }
      }
    }

    if (clients.openWindow) {
      return clients.openWindow('/');
    }
  }));
});</pre>

<h2 id="Specifications" style="line-height: 30px; font-size: 2.14285714285714rem;">Specifications</h2>

<table class="standard-table" style="line-height: 19.0909080505371px;">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Service Workers', '#dom-windowclient-visibilitystate', 'visibilityState')}}</td>
   <td>{{Spec2('Service Workers')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.WindowClient.visibilityState")}}</p>
</div>
